// Copyright none
#include "./Graph.h"
#include <string>
#include <sstream>

Graph::Graph() {
  _num_arcs = 0;
}

void Graph::addNode() {
  _adjecencylist.resize(_adjecencylist.size()+1);
}

void Graph::addArc(int u, int v) {
  Arc a;
  a.headNodeId = v;
  a.cost = 0;
  _adjecencylist[u].push_back(a);
  ++_num_arcs;
}

std::string Graph::toString() {
  std::ostringstream oss;
  oss << "{" << _adjecencylist.size() << ", " << _num_arcs;
  int u = 0;
  for (auto item: _adjecencylist) {
    for (auto v: item) {
      oss << ", (" << u << "," << v.headNodeId << ")";
    }
    ++u;
  }


  oss << "}";

  return oss.str();
}
